<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="specId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">已启用</a-tag>
              <a-tag v-if="record.status === 1" color="red">未启用</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openSpecValue(record)">规格值</a>
                <a-divider type="vertical" />
                <a @click="moveUp(record)">上移<ArrowUpOutlined /></a>
                <a-divider type="vertical" />
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <SpecEdit v-model:visible="showEdit" :data="current" @done="reload" />

      <!-- 规则值弹窗 -->
      <SpecValueEdit
        v-model:visible="showSpecValueEdit"
        :data="current"
        @done="reload"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import {
    ArrowUpOutlined,
    ExclamationCircleOutlined
  } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import SpecEdit from './components/specEdit.vue';
  import {
    pageSpec,
    removeSpec,
    removeBatchSpec,
    updateSpec
  } from '@/api/shop/spec';
  import type { Spec, SpecParam } from '@/api/shop/spec/model';
  import SpecValueEdit from '../specValue/index.vue';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Spec[]>([]);
  // 当前编辑数据
  const current = ref<Spec | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示规格值弹窗
  const showSpecValueEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageSpec({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      width: 90,
      dataIndex: 'specId'
    },
    {
      title: '规格名称',
      dataIndex: 'specName',
      width: 240,
      key: 'specName'
    },
    {
      title: '备注',
      dataIndex: 'comments',
      key: 'comments'
    },
    {
      title: '操作',
      key: 'action',
      width: 280,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: SpecParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Spec) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  const openSpecValue = (row?: Spec) => {
    current.value = row ?? null;
    showSpecValueEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: Spec) => {
    const hide = message.loading('请求中..', 0);
    removeSpec(row.specId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchSpec(selection.value.map((d) => d.specId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  // 上移
  const moveUp = (row?: Spec) => {
    updateSpec({
      specId: row?.specId,
      sortNumber: Number(row?.sortNumber) - 1
    }).then((msg) => {
      message.success(msg);
      reload();
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: Spec) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openSpecValue(record);
      }
    };
  };

  query();
</script>

<script lang="ts">
  export default {
    name: 'Spec'
  };
</script>

<style lang="less" scoped></style>
